"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
const core_1 = require('@angular/core');
let SliderComponent = class SliderComponent {
    constructor() {
        this.maxValue = 100;
        this.minValue = 0;
        this.offsetXRealFirst = 0;
        this.offsetXFirst = 0;
        this.offsetXRealSecond = 0;
        this.offsetXSecond = 0;
        this.isMousedownSecond = false;
        this.isMousedownFirst = false;
        //values percentage
        this.firstVal = 0;
        this.secondVal = 1;
        //margin of circle
        this.margin = 0;
        // private sliderElement: any;
        this.change = new core_1.EventEmitter();
    }
    ngOnInit() {
        console.log(this.sliderElement);
        this.margin = this.sliderElement.nativeElement.querySelector('.circle').offsetWidth / 2;
        this.offsetXRealFirst = this.offsetXFirst = this.offsetXRealSecond = this.offsetXSecond = -this.margin;
    }
    mousedownFirst(event) {
        this.isMousedownFirst = true;
    }
    mousedownSecond(event) {
        this.isMousedownSecond = true;
    }
    mouseup(event) {
        this.isMousedownFirst = false;
        this.isMousedownSecond = false;
        if (this.offsetXFirst < -this.margin) {
            this.offsetXFirst = -this.margin;
        }
        if (this.offsetXSecond < -this.margin) {
            this.offsetXSecond = -this.margin;
        }
    }
    mousemoveFirst(event) {
        if (this.isMousedownFirst) {
            this.offsetXFirst += event.movementX;
            if (this.offsetXFirst >= -this.margin && this.offsetXFirst <= this.sliderElement.nativeElement.offsetWidth - this.margin) {
                this.offsetXRealFirst = this.offsetXFirst;
                this.firstVal = (this.offsetXFirst + this.margin) / (this.sliderElement.nativeElement.offsetWidth);
                this.emitChanges();
            }
        }
    }
    mousemoveSecond(event) {
        if (this.isMousedownSecond) {
            this.offsetXSecond += -event.movementX;
            if (this.offsetXSecond >= -this.margin && this.offsetXSecond <= this.sliderElement.nativeElement.offsetWidth - this.margin) {
                this.offsetXRealSecond = this.offsetXSecond;
                this.secondVal = 1 - (this.offsetXSecond + this.margin) / (this.sliderElement.nativeElement.offsetWidth);
                this.emitChanges();
            }
        }
    }
    emitChanges() {
        this.change.emit({
            firstVal: this.getMinVal(),
            secondVal: this.getMaxVal()
        });
    }
    getMaxMinDiff() {
        return this.maxValue - this.minValue;
    }
    getMinVal() {
        return this.minValue + this.getMaxMinDiff() * this.firstVal;
    }
    getMaxVal() {
        return this.minValue + this.getMaxMinDiff() * this.secondVal;
    }
};
__decorate([
    core_1.Input(), 
    __metadata('design:type', Object)
], SliderComponent.prototype, "maxValue", void 0);
__decorate([
    core_1.Input(), 
    __metadata('design:type', Object)
], SliderComponent.prototype, "minValue", void 0);
__decorate([
    core_1.Output(), 
    __metadata('design:type', Object)
], SliderComponent.prototype, "change", void 0);
__decorate([
    core_1.ViewChild('simpleSlider'), 
    __metadata('design:type', Object)
], SliderComponent.prototype, "sliderElement", void 0);
SliderComponent = __decorate([
    core_1.Component({
        selector: 'slider',
        template: `
        <div #simpleSlider class="slider"  (window:mouseup)="mouseup($event)" value="hello">
            <div class="line">
                <div class="colorline" [style.width.px]="offsetXRealFirst" ></div>
                <div class="colorline line-right" [style.width.px]="offsetXRealSecond"></div>
                <div class="circle" 
                    [style.left.px]="offsetXRealFirst" 
                    (mousedown)="mousedownFirst($event)"
                    (window:mousemove)="mousemoveFirst($event)"></div>
                <div class="circle" 
                    [style.right.px]="offsetXRealSecond" 
                    (mousedown)="mousedownSecond($event)"
                    (window:mousemove)="mousemoveSecond($event)"></div>
            </div>
        </div>
    `,
        styles: [`
        .slider {
            user-select: none;
            position: relative;
            width: 100%;
            height: 16px;
            display: flex;
            flex-direction: column;
            justify-content: center;
        }
        .slider .line {
            width: 100%;
            height: 2px;
            background: #3F3CCB;
        }
            .slider .line .colorline {
                position: absolute;
                height: 2px;
                left: 0px;
                background: #CCC;
            }
            .slider .line .colorline.line-right {
                position: absolute;
                left: initial;
                right: 0px;
            }
            .slider .line .circle {
                position: absolute;
                border-radius: 100%;
                height: 16px;
                width: 16px;
                top: 0px;
            }
            .slider .line .circle:before {
                position: absolute;
                content: "";
                width: 16px;
                height: 16px;
                top: 0px;
                left: 0px;
                border-radius: 100%;
                box-shadow: inset 0px 0px 0px 2px #CCC;
                transition: all 0.4s;
                background: white;
            }
            
            .slider .line .circle:active:before,
            .slider .line .circle:hover:before {
                box-shadow: none;
                width: 18px;
                height: 18px;
                top: -1px;
                left: -1px;
                background: #3F3CCB;
            }
    `]
    }), 
    __metadata('design:paramtypes', [])
], SliderComponent);
exports.SliderComponent = SliderComponent;
//# sourceMappingURL=slider.component.js.map